/** generated file, do not edit! */
#ifndef DT_CONFGEN_H
#define DT_CONFGEN_H

#include "control/conf.h"

static void _insert_default(const char *name, const char *value)
{
  dt_confgen_value_t *item = (dt_confgen_value_t *)g_hash_table_lookup(darktable.conf->x_confgen, name);

  if(item)
  {
     g_free(item->def);
  }
  else
  {
     item = (dt_confgen_value_t *)g_malloc0(sizeof(dt_confgen_value_t));
     g_hash_table_insert(darktable.conf->x_confgen, g_strdup(name), item);
  }
  item->def = g_strdup(value);
}

static void _insert_values(const char *name, const char *values)
{
  dt_confgen_value_t *item = (dt_confgen_value_t *)g_hash_table_lookup(darktable.conf->x_confgen, name);

  if(item)
  {
     g_free(item->enum_values);
  }
  else
  {
     item = (dt_confgen_value_t *)g_malloc0(sizeof(dt_confgen_value_t));
     g_hash_table_insert(darktable.conf->x_confgen, g_strdup(name), item);
  }
  item->enum_values = g_strdup(values);
}

static void _insert_min(const char *name, const char *value)
{
  dt_confgen_value_t *item = (dt_confgen_value_t *)g_hash_table_lookup(darktable.conf->x_confgen, name);

  if(item)
  {
     g_free(item->min);
  }
  else
  {
     item = (dt_confgen_value_t *)g_malloc0(sizeof(dt_confgen_value_t));
     g_hash_table_insert(darktable.conf->x_confgen, g_strdup(name), item);
  }
  item->min = g_strdup(value);
}

static void _insert_max(const char *name, const char *value)
{
  dt_confgen_value_t *item = (dt_confgen_value_t *)g_hash_table_lookup(darktable.conf->x_confgen, name);

  if(item)
  {
     g_free(item->max);
  }
  else
  {
     item = (dt_confgen_value_t *)g_malloc0(sizeof(dt_confgen_value_t));
     g_hash_table_insert(darktable.conf->x_confgen, g_strdup(name), item);
  }
  item->max = g_strdup(value);
}

static void _insert_type(const char *name, const char *value)
{
  dt_confgen_value_t *item = (dt_confgen_value_t *)g_hash_table_lookup(darktable.conf->x_confgen, name);

  if(!item)
  {
     item = (dt_confgen_value_t *)g_malloc0(sizeof(dt_confgen_value_t));
     g_hash_table_insert(darktable.conf->x_confgen, g_strdup(name), item);
  }

  if      (!strcmp(value, "int"))   item->type = DT_INT;
  else if (!strcmp(value, "int64")) item->type = DT_INT64;
  else if (!strcmp(value, "bool"))  item->type = DT_BOOL;
  else if (!strcmp(value, "float")) item->type = DT_FLOAT;
  else if (!strcmp(value, "enum"))  item->type = DT_ENUM;
  else                              item->type = DT_STRING;
}

void dt_confgen_init()
{
   // themes/usercss
   _insert_default("themes/usercss", "true");
   _insert_type("themes/usercss", "bool");

   // accel/prefer_expanded
   _insert_default("accel/prefer_expanded", "false");
   _insert_type("accel/prefer_expanded", "bool");

   // accel/prefer_enabled
   _insert_default("accel/prefer_enabled", "false");
   _insert_type("accel/prefer_enabled", "bool");

   // accel/prefer_unmasked
   _insert_default("accel/prefer_unmasked", "false");
   _insert_type("accel/prefer_unmasked", "bool");

   // accel/select_order
   _insert_default("accel/select_order", "last instance");
   _insert_type("accel/select_order", "enum");
   _insert_values("accel/select_order", "[first instance][last instance]");

   // accel/slider_precision
   _insert_default("accel/slider_precision", "0");
   _insert_type("accel/slider_precision", "int");

   // bauhaus/scale
   _insert_default("bauhaus/scale", "1.4");
   _insert_type("bauhaus/scale", "float");

   // database
   _insert_default("database", "library.db");
   _insert_type("database", "string");

   // database/maintenance_check
   _insert_default("database/maintenance_check", "on close");
   _insert_type("database/maintenance_check", "enum");
   _insert_values("database/maintenance_check", "[never][on startup][on close][on both][on startup (don't ask)][on close (don't ask)][on both (don't ask)]");

   // database/maintenance_freepage_ratio
   _insert_default("database/maintenance_freepage_ratio", "25");
   _insert_type("database/maintenance_freepage_ratio", "int");

   // database/create_snapshot
   _insert_default("database/create_snapshot", "once a week");
   _insert_type("database/create_snapshot", "enum");
   _insert_values("database/create_snapshot", "[never][once a month][once a week][once a day][on close]");

   // database/keep_snapshots
   _insert_default("database/keep_snapshots", "10");
   _insert_type("database/keep_snapshots", "int");

   // min_panel_width
   _insert_default("min_panel_width", "150");
   _insert_type("min_panel_width", "int");

   // max_panel_width
   _insert_default("max_panel_width", "500");
   _insert_type("max_panel_width", "int");

   // min_panel_height
   _insert_default("min_panel_height", "64");
   _insert_type("min_panel_height", "int");

   // max_panel_height
   _insert_default("max_panel_height", "400");
   _insert_type("max_panel_height", "int");

   // slideshow_delay
   _insert_default("slideshow_delay", "5");
   _insert_type("slideshow_delay", "int");

   // ui_last/no_april1st
   _insert_default("ui_last/no_april1st", "true");
   _insert_type("ui_last/no_april1st", "bool");

   // cache_memory
   _insert_default("cache_memory", "(1024 * 1024 * 512)");
   _insert_type("cache_memory", "int64");
   _insert_min("cache_memory", "(1024 * 1024 * 100)");

   // cache_disk_backend
   _insert_default("cache_disk_backend", "true");
   _insert_type("cache_disk_backend", "bool");

   // cache_disk_backend_full
   _insert_default("cache_disk_backend_full", "false");
   _insert_type("cache_disk_backend_full", "bool");

   // cache_color_managed
   _insert_default("cache_color_managed", "true");
   _insert_type("cache_color_managed", "bool");

   // worker_threads
   _insert_default("worker_threads", "2");
   _insert_type("worker_threads", "int");
   _insert_min("worker_threads", "1");
   _insert_max("worker_threads", "64");

   // host_memory_limit
   _insert_default("host_memory_limit", "1500");
   _insert_type("host_memory_limit", "int");

   // singlebuffer_limit
   _insert_default("singlebuffer_limit", "16");
   _insert_type("singlebuffer_limit", "int");
   _insert_min("singlebuffer_limit", "2");
   _insert_max("singlebuffer_limit", "64");

   // opencl_memory_headroom
   _insert_default("opencl_memory_headroom", "400");
   _insert_type("opencl_memory_headroom", "int");

   // opencl_avoid_atomics
   _insert_default("opencl_avoid_atomics", "false");
   _insert_type("opencl_avoid_atomics", "bool");

   // opencl_number_event_handles
   _insert_default("opencl_number_event_handles", "25");
   _insert_type("opencl_number_event_handles", "int");

   // opencl_async_pixelpipe
   _insert_default("opencl_async_pixelpipe", "false");
   _insert_type("opencl_async_pixelpipe", "bool");

   // opencl_micro_nap
   _insert_default("opencl_micro_nap", "1000");
   _insert_type("opencl_micro_nap", "int");

   // opencl_device_priority
   _insert_default("opencl_device_priority", "*/!0,*/*/*/!0,*");
   _insert_type("opencl_device_priority", "string");

   // opencl_mandatory_timeout
   _insert_default("opencl_mandatory_timeout", "200");
   _insert_type("opencl_mandatory_timeout", "int");
   _insert_min("opencl_mandatory_timeout", "0");

   // opencl_use_pinned_memory
   _insert_default("opencl_use_pinned_memory", "false");
   _insert_type("opencl_use_pinned_memory", "bool");

   // opencl_use_cpu_devices
   _insert_default("opencl_use_cpu_devices", "false");
   _insert_type("opencl_use_cpu_devices", "bool");

   // opencl_disable_drivers_blacklist
   _insert_default("opencl_disable_drivers_blacklist", "false");
   _insert_type("opencl_disable_drivers_blacklist", "bool");

   // opencl_checksum
   _insert_default("opencl_checksum", "");
   _insert_type("opencl_checksum", "string");

   // pixelpipe_synchronization_timeout
   _insert_default("pixelpipe_synchronization_timeout", "200");
   _insert_type("pixelpipe_synchronization_timeout", "int");

   // never_use_embedded_thumb
   _insert_default("never_use_embedded_thumb", "false");
   _insert_type("never_use_embedded_thumb", "bool");

   // write_sidecar_files
   _insert_default("write_sidecar_files", "true");
   _insert_type("write_sidecar_files", "bool");

   // compress_xmp_tags
   _insert_default("compress_xmp_tags", "only large entries");
   _insert_type("compress_xmp_tags", "enum");
   _insert_values("compress_xmp_tags", "[never][always][only large entries]");

   // omit_tag_hierarchy
   _insert_default("omit_tag_hierarchy", "false");
   _insert_type("omit_tag_hierarchy", "bool");

   // plugins/lighttable/tagging/no_entry_completion
   _insert_default("plugins/lighttable/tagging/no_entry_completion", "false");
   _insert_type("plugins/lighttable/tagging/no_entry_completion", "bool");

   // opencl
   _insert_default("opencl", "true");
   _insert_type("opencl", "bool");

   // opencl_scheduling_profile
   _insert_default("opencl_scheduling_profile", "default");
   _insert_type("opencl_scheduling_profile", "enum");
   _insert_values("opencl_scheduling_profile", "[default][multiple GPUs][very fast GPU]");

   // opencl_synch_cache
   _insert_default("opencl_synch_cache", "active module");
   _insert_type("opencl_synch_cache", "enum");
   _insert_values("opencl_synch_cache", "[true][active module][false]");

   // opencl_library
   _insert_default("opencl_library", "");
   _insert_type("opencl_library", "string");

   // opencl_memory_requirement
   _insert_default("opencl_memory_requirement", "768");
   _insert_type("opencl_memory_requirement", "int");

   // opencl_size_roundup
   _insert_default("opencl_size_roundup", "16");
   _insert_type("opencl_size_roundup", "int");

   // maximum_number_tiles
   _insert_default("maximum_number_tiles", "10000");
   _insert_type("maximum_number_tiles", "int");

   // ask_before_remove
   _insert_default("ask_before_remove", "true");
   _insert_type("ask_before_remove", "bool");

   // ask_before_delete
   _insert_default("ask_before_delete", "true");
   _insert_type("ask_before_delete", "bool");

   // ask_before_discard
   _insert_default("ask_before_discard", "true");
   _insert_type("ask_before_discard", "bool");

   // send_to_trash
   _insert_default("send_to_trash", "true");
   _insert_type("send_to_trash", "bool");

   // ask_before_move
   _insert_default("ask_before_move", "true");
   _insert_type("ask_before_move", "bool");

   // ask_before_copy
   _insert_default("ask_before_copy", "true");
   _insert_type("ask_before_copy", "bool");

   // ask_before_rmdir
   _insert_default("ask_before_rmdir", "false");
   _insert_type("ask_before_rmdir", "bool");

   // show_folder_levels
   _insert_default("show_folder_levels", "1");
   _insert_type("show_folder_levels", "int");
   _insert_min("show_folder_levels", "1");
   _insert_max("show_folder_levels", "5");

   // plugins/collection/film_id
   _insert_default("plugins/collection/film_id", "1");
   _insert_type("plugins/collection/film_id", "int");

   // plugins/collection/rating
   _insert_default("plugins/collection/rating", "1");
   _insert_type("plugins/collection/rating", "int");

   // plugins/collection/rating_comparator
   _insert_default("plugins/collection/rating_comparator", "3");
   _insert_type("plugins/collection/rating_comparator", "int");

   // plugins/collection/query_flags
   _insert_default("plugins/collection/query_flags", "3");
   _insert_type("plugins/collection/query_flags", "int");

   // plugins/collection/filter_flags
   _insert_default("plugins/collection/filter_flags", "3");
   _insert_type("plugins/collection/filter_flags", "int");

   // plugins/collection/descending
   _insert_default("plugins/collection/descending", "false");
   _insert_type("plugins/collection/descending", "bool");

   // plugins/collection/sort
   _insert_default("plugins/collection/sort", "0");
   _insert_type("plugins/collection/sort", "int");

   // plugins/session/jobcode
   _insert_default("plugins/session/jobcode", "capture job");
   _insert_type("plugins/session/jobcode", "string");

   // plugins/capture/storage/basedirectory
   _insert_default("plugins/capture/storage/basedirectory", "$(PICTURES_FOLDER)/darktable");
   _insert_type("plugins/capture/storage/basedirectory", "string");

   // plugins/capture/storage/subpath
   _insert_default("plugins/capture/storage/subpath", "$(YEAR)$(MONTH)$(DAY)_$(JOBCODE)");
   _insert_type("plugins/capture/storage/subpath", "string");

   // plugins/capture/storage/namepattern
   _insert_default("plugins/capture/storage/namepattern", "$(YEAR)$(MONTH)$(DAY)_$(SEQUENCE).$(FILE_EXTENSION)");
   _insert_type("plugins/capture/storage/namepattern", "string");

   // plugins/capture/camera/import/jobcode
   _insert_default("plugins/capture/camera/import/jobcode", "noname");
   _insert_type("plugins/capture/camera/import/jobcode", "string");

   // plugins/capture/camera/live_view_fps
   _insert_default("plugins/capture/camera/live_view_fps", "15");
   _insert_type("plugins/capture/camera/live_view_fps", "int");

   // plugins/collect/filmroll_sort
   _insert_default("plugins/collect/filmroll_sort", "id");
   _insert_type("plugins/collect/filmroll_sort", "enum");
   _insert_values("plugins/collect/filmroll_sort", "[id][folder]");

   // plugins/collect/descending
   _insert_default("plugins/collect/descending", "true");
   _insert_type("plugins/collect/descending", "bool");

   // ui_last/colorpicker_mean
   _insert_default("ui_last/colorpicker_mean", "0");
   _insert_type("ui_last/colorpicker_mean", "int");

   // ui_last/fullscreen
   _insert_default("ui_last/fullscreen", "false");
   _insert_type("ui_last/fullscreen", "bool");

   // ui_last/maximized
   _insert_default("ui_last/maximized", "true");
   _insert_type("ui_last/maximized", "bool");

   // ui_last/grouping
   _insert_default("ui_last/grouping", "false");
   _insert_type("ui_last/grouping", "bool");

   // ui_last/view
   _insert_default("ui_last/view", "0");
   _insert_type("ui_last/view", "int");

   // ui_last/window_x
   _insert_default("ui_last/window_x", "0");
   _insert_type("ui_last/window_x", "int");

   // ui_last/window_y
   _insert_default("ui_last/window_y", "0");
   _insert_type("ui_last/window_y", "int");

   // ui_last/window_w
   _insert_default("ui_last/window_w", "900");
   _insert_type("ui_last/window_w", "int");

   // ui_last/window_h
   _insert_default("ui_last/window_h", "500");
   _insert_type("ui_last/window_h", "int");

   // ui_last/panel_left
   _insert_default("ui_last/panel_left", "-1");
   _insert_type("ui_last/panel_left", "int");

   // ui_last/panel_right
   _insert_default("ui_last/panel_right", "-1");
   _insert_type("ui_last/panel_right", "int");

   // ui_last/panel_top
   _insert_default("ui_last/panel_top", "0");
   _insert_type("ui_last/panel_top", "int");

   // ui_last/panel_bottom
   _insert_default("ui_last/panel_bottom", "0");
   _insert_type("ui_last/panel_bottom", "int");

   // ui_last/expander_import
   _insert_default("ui_last/expander_import", "2");
   _insert_type("ui_last/expander_import", "int");

   // ui_last/import_ignore_jpegs
   _insert_default("ui_last/import_ignore_jpegs", "false");
   _insert_type("ui_last/import_ignore_jpegs", "bool");

   // ui_last/import_recursive
   _insert_default("ui_last/import_recursive", "false");
   _insert_type("ui_last/import_recursive", "bool");

   // ui_last/import_last_creator
   _insert_default("ui_last/import_last_creator", "");
   _insert_type("ui_last/import_last_creator", "string");

   // ui_last/import_last_publisher
   _insert_default("ui_last/import_last_publisher", "");
   _insert_type("ui_last/import_last_publisher", "string");

   // ui_last/import_last_rights
   _insert_default("ui_last/import_last_rights", "");
   _insert_type("ui_last/import_last_rights", "string");

   // ui_last/import_last_tags
   _insert_default("ui_last/import_last_tags", "");
   _insert_type("ui_last/import_last_tags", "string");

   // ui_last/import_last_directory
   _insert_default("ui_last/import_last_directory", "");
   _insert_type("ui_last/import_last_directory", "string");

   // ui_last/import_initial_rating
   _insert_default("ui_last/import_initial_rating", "1");
   _insert_type("ui_last/import_initial_rating", "int");
   _insert_min("ui_last/import_initial_rating", "0");
   _insert_max("ui_last/import_initial_rating", "5");

   // plugins/capture/mode
   _insert_default("plugins/capture/mode", "0");
   _insert_type("plugins/capture/mode", "int");

   // plugins/lighttable/overlay_timeout
   _insert_default("plugins/lighttable/overlay_timeout", "3");
   _insert_type("plugins/lighttable/overlay_timeout", "int");

   // plugins/lighttable/overlays/0/0
   _insert_default("plugins/lighttable/overlays/0/0", "0");
   _insert_type("plugins/lighttable/overlays/0/0", "int");

   // plugins/lighttable/overlays/0/1
   _insert_default("plugins/lighttable/overlays/0/1", "1");
   _insert_type("plugins/lighttable/overlays/0/1", "int");

   // plugins/lighttable/overlays/0/2
   _insert_default("plugins/lighttable/overlays/0/2", "4");
   _insert_type("plugins/lighttable/overlays/0/2", "int");

   // plugins/lighttable/overlays/1/0
   _insert_default("plugins/lighttable/overlays/1/0", "0");
   _insert_type("plugins/lighttable/overlays/1/0", "int");

   // plugins/lighttable/overlays/1/1
   _insert_default("plugins/lighttable/overlays/1/1", "1");
   _insert_type("plugins/lighttable/overlays/1/1", "int");

   // plugins/lighttable/overlays/1/2
   _insert_default("plugins/lighttable/overlays/1/2", "1");
   _insert_type("plugins/lighttable/overlays/1/2", "int");

   // plugins/lighttable/overlays/2/0
   _insert_default("plugins/lighttable/overlays/2/0", "0");
   _insert_type("plugins/lighttable/overlays/2/0", "int");

   // plugins/lighttable/overlays/2/1
   _insert_default("plugins/lighttable/overlays/2/1", "1");
   _insert_type("plugins/lighttable/overlays/2/1", "int");

   // plugins/lighttable/overlays/2/2
   _insert_default("plugins/lighttable/overlays/2/2", "4");
   _insert_type("plugins/lighttable/overlays/2/2", "int");

   // plugins/lighttable/overlays/culling/0
   _insert_default("plugins/lighttable/overlays/culling/0", "6");
   _insert_type("plugins/lighttable/overlays/culling/0", "int");

   // plugins/lighttable/overlays/culling/1
   _insert_default("plugins/lighttable/overlays/culling/1", "6");
   _insert_type("plugins/lighttable/overlays/culling/1", "int");

   // plugins/lighttable/tooltips/0/0
   _insert_default("plugins/lighttable/tooltips/0/0", "true");
   _insert_type("plugins/lighttable/tooltips/0/0", "bool");

   // plugins/lighttable/tooltips/0/1
   _insert_default("plugins/lighttable/tooltips/0/1", "true");
   _insert_type("plugins/lighttable/tooltips/0/1", "bool");

   // plugins/lighttable/tooltips/0/2
   _insert_default("plugins/lighttable/tooltips/0/2", "false");
   _insert_type("plugins/lighttable/tooltips/0/2", "bool");

   // plugins/lighttable/tooltips/1/0
   _insert_default("plugins/lighttable/tooltips/1/0", "true");
   _insert_type("plugins/lighttable/tooltips/1/0", "bool");

   // plugins/lighttable/tooltips/1/1
   _insert_default("plugins/lighttable/tooltips/1/1", "true");
   _insert_type("plugins/lighttable/tooltips/1/1", "bool");

   // plugins/lighttable/tooltips/1/2
   _insert_default("plugins/lighttable/tooltips/1/2", "true");
   _insert_type("plugins/lighttable/tooltips/1/2", "bool");

   // plugins/lighttable/tooltips/2/0
   _insert_default("plugins/lighttable/tooltips/2/0", "true");
   _insert_type("plugins/lighttable/tooltips/2/0", "bool");

   // plugins/lighttable/tooltips/2/1
   _insert_default("plugins/lighttable/tooltips/2/1", "true");
   _insert_type("plugins/lighttable/tooltips/2/1", "bool");

   // plugins/lighttable/tooltips/2/2
   _insert_default("plugins/lighttable/tooltips/2/2", "false");
   _insert_type("plugins/lighttable/tooltips/2/2", "bool");

   // plugins/lighttable/tooltips/culling/0
   _insert_default("plugins/lighttable/tooltips/culling/0", "false");
   _insert_type("plugins/lighttable/tooltips/culling/0", "bool");

   // plugins/lighttable/tooltips/culling/1
   _insert_default("plugins/lighttable/tooltips/culling/1", "false");
   _insert_type("plugins/lighttable/tooltips/culling/1", "bool");

   // plugins/lighttable/timeline/last_zoom
   _insert_default("plugins/lighttable/timeline/last_zoom", "0");
   _insert_type("plugins/lighttable/timeline/last_zoom", "int");

   // plugins/lighttable/low_quality_thumbnails
   _insert_default("plugins/lighttable/low_quality_thumbnails", "false");
   _insert_type("plugins/lighttable/low_quality_thumbnails", "bool");

   // plugins/lighttable/thumbnail_hq_min_level
   _insert_default("plugins/lighttable/thumbnail_hq_min_level", "720p");
   _insert_type("plugins/lighttable/thumbnail_hq_min_level", "enum");
   _insert_values("plugins/lighttable/thumbnail_hq_min_level", "[always][small][VGA][720p][1080p][WQXGA][4K][5K][never]");

   // plugins/lighttable/thumbnail_sizes
   _insert_default("plugins/lighttable/thumbnail_sizes", "120|400");
   _insert_type("plugins/lighttable/thumbnail_sizes", "string");

   // plugins/lighttable/extended_pattern
   _insert_default("plugins/lighttable/extended_pattern", "$(FILE_NAME).$(FILE_EXTENSION)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH)mm • $(EXIF_ISO) ISO $(SIDECAR_TXT)");
   _insert_type("plugins/lighttable/extended_pattern", "longstring");

   // plugins/lighttable/thumbnail_tooltip_pattern
   _insert_default("plugins/lighttable/thumbnail_tooltip_pattern", "<b>$(FILE_NAME).$(FILE_EXTENSION)</b>$(NL)$(EXIF_DAY)/$(EXIF_MONTH)/$(EXIF_YEAR) $(EXIF_HOUR):$(EXIF_MINUTE):$(EXIF_SECOND)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO");
   _insert_type("plugins/lighttable/thumbnail_tooltip_pattern", "longstring");

   // pressure_sensitivity
   _insert_default("pressure_sensitivity", "off");
   _insert_type("pressure_sensitivity", "enum");
   _insert_values("pressure_sensitivity", "[off][hardness (relative)][hardness (absolute)][opacity (relative)][opacity (absolute)][brush size (relative)]");

   // brush_smoothing
   _insert_default("brush_smoothing", "medium");
   _insert_type("brush_smoothing", "enum");
   _insert_values("brush_smoothing", "[low][medium][high]");

   // channel_display
   _insert_default("channel_display", "false color");
   _insert_type("channel_display", "enum");
   _insert_values("channel_display", "[false color][grey scale]");

   // plugins/darkroom/image_infos_pattern
   _insert_default("plugins/darkroom/image_infos_pattern", "$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO");
   _insert_type("plugins/darkroom/image_infos_pattern", "longstring");

   // plugins/darkroom/image_infos_position
   _insert_default("plugins/darkroom/image_infos_position", "bottom");
   _insert_type("plugins/darkroom/image_infos_position", "enum");
   _insert_values("plugins/darkroom/image_infos_position", "[top left][top right][top center][bottom][hidden]");

   // database_cache_quality
   _insert_default("database_cache_quality", "89");
   _insert_type("database_cache_quality", "int");

   // plugins/lighttable/draw_group_borders
   _insert_default("plugins/lighttable/draw_group_borders", "true");
   _insert_type("plugins/lighttable/draw_group_borders", "bool");

   // modules/default_presets_first
   _insert_default("modules/default_presets_first", "true");
   _insert_type("modules/default_presets_first", "bool");

   // plugins/darkroom/hide_default_presets
   _insert_default("plugins/darkroom/hide_default_presets", "false");
   _insert_type("plugins/darkroom/hide_default_presets", "bool");

   // plugins/lighttable/hide_default_presets
   _insert_default("plugins/lighttable/hide_default_presets", "false");
   _insert_type("plugins/lighttable/hide_default_presets", "bool");

   // session/base_directory_pattern
   _insert_default("session/base_directory_pattern", "$(PICTURES_FOLDER)/Darktable");
   _insert_type("session/base_directory_pattern", "string");

   // session/sub_directory_pattern
   _insert_default("session/sub_directory_pattern", "$(YEAR)$(MONTH)$(DAY)_$(JOBCODE)");
   _insert_type("session/sub_directory_pattern", "string");

   // session/use_filename
   _insert_default("session/use_filename", "false");
   _insert_type("session/use_filename", "bool");

   // session/filename_pattern
   _insert_default("session/filename_pattern", "$(YEAR)$(MONTH)$(DAY)_$(SEQUENCE).$(FILE_EXTENSION)");
   _insert_type("session/filename_pattern", "string");

   // plugins/lighttable/layout
   _insert_default("plugins/lighttable/layout", "1");
   _insert_type("plugins/lighttable/layout", "int");

   // plugins/lighttable/base_layout
   _insert_default("plugins/lighttable/base_layout", "1");
   _insert_type("plugins/lighttable/base_layout", "int");

   // plugins/lighttable/images_in_row
   _insert_default("plugins/lighttable/images_in_row", "5");
   _insert_type("plugins/lighttable/images_in_row", "int");

   // plugins/lighttable/culling_num_images
   _insert_default("plugins/lighttable/culling_num_images", "2");
   _insert_type("plugins/lighttable/culling_num_images", "int");

   // plugins/lighttable/culling_zoom_mode
   _insert_default("plugins/lighttable/culling_zoom_mode", "0");
   _insert_type("plugins/lighttable/culling_zoom_mode", "int");

   // plugins/lighttable/culling_last_id
   _insert_default("plugins/lighttable/culling_last_id", "-1");
   _insert_type("plugins/lighttable/culling_last_id", "int");

   // plugins/lighttable/recentcollect/num_items
   _insert_default("plugins/lighttable/recentcollect/num_items", "0");
   _insert_type("plugins/lighttable/recentcollect/num_items", "int");

   // plugins/lighttable/recentcollect/line0
   _insert_default("plugins/lighttable/recentcollect/line0", "");
   _insert_type("plugins/lighttable/recentcollect/line0", "string");

   // plugins/lighttable/recentcollect/line1
   _insert_default("plugins/lighttable/recentcollect/line1", "");
   _insert_type("plugins/lighttable/recentcollect/line1", "string");

   // plugins/lighttable/recentcollect/line2
   _insert_default("plugins/lighttable/recentcollect/line2", "");
   _insert_type("plugins/lighttable/recentcollect/line2", "string");

   // plugins/lighttable/recentcollect/line3
   _insert_default("plugins/lighttable/recentcollect/line3", "");
   _insert_type("plugins/lighttable/recentcollect/line3", "string");

   // plugins/lighttable/recentcollect/line4
   _insert_default("plugins/lighttable/recentcollect/line4", "");
   _insert_type("plugins/lighttable/recentcollect/line4", "string");

   // plugins/lighttable/recentcollect/line5
   _insert_default("plugins/lighttable/recentcollect/line5", "");
   _insert_type("plugins/lighttable/recentcollect/line5", "string");

   // plugins/lighttable/recentcollect/line6
   _insert_default("plugins/lighttable/recentcollect/line6", "");
   _insert_type("plugins/lighttable/recentcollect/line6", "string");

   // plugins/lighttable/recentcollect/line7
   _insert_default("plugins/lighttable/recentcollect/line7", "");
   _insert_type("plugins/lighttable/recentcollect/line7", "string");

   // plugins/lighttable/recentcollect/line8
   _insert_default("plugins/lighttable/recentcollect/line8", "");
   _insert_type("plugins/lighttable/recentcollect/line8", "string");

   // plugins/lighttable/recentcollect/line9
   _insert_default("plugins/lighttable/recentcollect/line9", "");
   _insert_type("plugins/lighttable/recentcollect/line9", "string");

   // plugins/lighttable/copy_history/pastemode
   _insert_default("plugins/lighttable/copy_history/pastemode", "0");
   _insert_type("plugins/lighttable/copy_history/pastemode", "int");

   // plugins/lighttable/collect/single-click
   _insert_default("plugins/lighttable/collect/single-click", "false");
   _insert_type("plugins/lighttable/collect/single-click", "bool");

   // plugins/lighttable/collect/num_rules
   _insert_default("plugins/lighttable/collect/num_rules", "0");
   _insert_type("plugins/lighttable/collect/num_rules", "int");

   // plugins/lighttable/collect/item0
   _insert_default("plugins/lighttable/collect/item0", "0");
   _insert_type("plugins/lighttable/collect/item0", "int");

   // plugins/lighttable/collect/string0
   _insert_default("plugins/lighttable/collect/string0", "");
   _insert_type("plugins/lighttable/collect/string0", "string");

   // plugins/lighttable/collect/item1
   _insert_default("plugins/lighttable/collect/item1", "0");
   _insert_type("plugins/lighttable/collect/item1", "int");

   // plugins/lighttable/collect/string1
   _insert_default("plugins/lighttable/collect/string1", "");
   _insert_type("plugins/lighttable/collect/string1", "string");

   // plugins/lighttable/collect/item2
   _insert_default("plugins/lighttable/collect/item2", "0");
   _insert_type("plugins/lighttable/collect/item2", "int");

   // plugins/lighttable/collect/string2
   _insert_default("plugins/lighttable/collect/string2", "");
   _insert_type("plugins/lighttable/collect/string2", "string");

   // plugins/lighttable/collect/item3
   _insert_default("plugins/lighttable/collect/item3", "0");
   _insert_type("plugins/lighttable/collect/item3", "int");

   // plugins/lighttable/collect/string3
   _insert_default("plugins/lighttable/collect/string3", "");
   _insert_type("plugins/lighttable/collect/string3", "string");

   // plugins/lighttable/collect/item4
   _insert_default("plugins/lighttable/collect/item4", "0");
   _insert_type("plugins/lighttable/collect/item4", "int");

   // plugins/lighttable/collect/string4
   _insert_default("plugins/lighttable/collect/string4", "");
   _insert_type("plugins/lighttable/collect/string4", "string");

   // plugins/lighttable/collect/item5
   _insert_default("plugins/lighttable/collect/item5", "0");
   _insert_type("plugins/lighttable/collect/item5", "int");

   // plugins/lighttable/collect/string5
   _insert_default("plugins/lighttable/collect/string5", "");
   _insert_type("plugins/lighttable/collect/string5", "string");

   // plugins/lighttable/collect/item6
   _insert_default("plugins/lighttable/collect/item6", "0");
   _insert_type("plugins/lighttable/collect/item6", "int");

   // plugins/lighttable/collect/string6
   _insert_default("plugins/lighttable/collect/string6", "");
   _insert_type("plugins/lighttable/collect/string6", "string");

   // plugins/lighttable/collect/item7
   _insert_default("plugins/lighttable/collect/item7", "0");
   _insert_type("plugins/lighttable/collect/item7", "int");

   // plugins/lighttable/collect/string7
   _insert_default("plugins/lighttable/collect/string7", "");
   _insert_type("plugins/lighttable/collect/string7", "string");

   // plugins/lighttable/collect/item8
   _insert_default("plugins/lighttable/collect/item8", "0");
   _insert_type("plugins/lighttable/collect/item8", "int");

   // plugins/lighttable/collect/string8
   _insert_default("plugins/lighttable/collect/string8", "");
   _insert_type("plugins/lighttable/collect/string8", "string");

   // plugins/lighttable/collect/item9
   _insert_default("plugins/lighttable/collect/item9", "0");
   _insert_type("plugins/lighttable/collect/item9", "int");

   // plugins/lighttable/collect/string9
   _insert_default("plugins/lighttable/collect/string9", "");
   _insert_type("plugins/lighttable/collect/string9", "string");

   // plugins/lighttable/collect/mode0
   _insert_default("plugins/lighttable/collect/mode0", "0");
   _insert_type("plugins/lighttable/collect/mode0", "int");

   // plugins/lighttable/collect/mode1
   _insert_default("plugins/lighttable/collect/mode1", "0");
   _insert_type("plugins/lighttable/collect/mode1", "int");

   // plugins/lighttable/collect/mode2
   _insert_default("plugins/lighttable/collect/mode2", "0");
   _insert_type("plugins/lighttable/collect/mode2", "int");

   // plugins/lighttable/collect/mode3
   _insert_default("plugins/lighttable/collect/mode3", "0");
   _insert_type("plugins/lighttable/collect/mode3", "int");

   // plugins/lighttable/collect/mode4
   _insert_default("plugins/lighttable/collect/mode4", "0");
   _insert_type("plugins/lighttable/collect/mode4", "int");

   // plugins/lighttable/collect/mode5
   _insert_default("plugins/lighttable/collect/mode5", "0");
   _insert_type("plugins/lighttable/collect/mode5", "int");

   // plugins/lighttable/collect/mode6
   _insert_default("plugins/lighttable/collect/mode6", "0");
   _insert_type("plugins/lighttable/collect/mode6", "int");

   // plugins/lighttable/collect/mode7
   _insert_default("plugins/lighttable/collect/mode7", "0");
   _insert_type("plugins/lighttable/collect/mode7", "int");

   // plugins/lighttable/collect/mode8
   _insert_default("plugins/lighttable/collect/mode8", "0");
   _insert_type("plugins/lighttable/collect/mode8", "int");

   // plugins/lighttable/collect/mode9
   _insert_default("plugins/lighttable/collect/mode9", "0");
   _insert_type("plugins/lighttable/collect/mode9", "int");

   // plugins/darkroom/tagging/visible
   _insert_default("plugins/darkroom/tagging/visible", "true");
   _insert_type("plugins/darkroom/tagging/visible", "bool");

   // plugins/lighttable/tagging/ask_before_delete_tag
   _insert_default("plugins/lighttable/tagging/ask_before_delete_tag", "true");
   _insert_type("plugins/lighttable/tagging/ask_before_delete_tag", "bool");

   // plugins/lighttable/tagging/dttags
   _insert_default("plugins/lighttable/tagging/dttags", "false");
   _insert_type("plugins/lighttable/tagging/dttags", "bool");

   // plugins/lighttable/tagging/nosuggestion
   _insert_default("plugins/lighttable/tagging/nosuggestion", "false");
   _insert_type("plugins/lighttable/tagging/nosuggestion", "bool");

   // plugins/lighttable/tagging/treeview
   _insert_default("plugins/lighttable/tagging/treeview", "false");
   _insert_type("plugins/lighttable/tagging/treeview", "bool");

   // plugins/lighttable/tagging/hidehierarchy
   _insert_default("plugins/lighttable/tagging/hidehierarchy", "false");
   _insert_type("plugins/lighttable/tagging/hidehierarchy", "bool");

   // plugins/lighttable/tagging/listsortedbycount
   _insert_default("plugins/lighttable/tagging/listsortedbycount", "false");
   _insert_type("plugins/lighttable/tagging/listsortedbycount", "bool");

   // plugins/lighttable/style/ask_before_delete_style
   _insert_default("plugins/lighttable/style/ask_before_delete_style", "true");
   _insert_type("plugins/lighttable/style/ask_before_delete_style", "bool");

   // plugins/lighttable/preset/ask_before_delete_preset
   _insert_default("plugins/lighttable/preset/ask_before_delete_preset", "true");
   _insert_type("plugins/lighttable/preset/ask_before_delete_preset", "bool");

   // plugins/map/show_map_osd
   _insert_default("plugins/map/show_map_osd", "true");
   _insert_type("plugins/map/show_map_osd", "bool");

   // plugins/map/show_outline
   _insert_default("plugins/map/show_outline", "true");
   _insert_type("plugins/map/show_outline", "bool");

   // plugins/map/max_outline_nodes
   _insert_default("plugins/map/max_outline_nodes", "10000");
   _insert_type("plugins/map/max_outline_nodes", "int");

   // plugins/map/max_images_drawn
   _insert_default("plugins/map/max_images_drawn", "100");
   _insert_type("plugins/map/max_images_drawn", "int");

   // plugins/lighttable/metadata_view/pretty_location
   _insert_default("plugins/lighttable/metadata_view/pretty_location", "true");
   _insert_type("plugins/lighttable/metadata_view/pretty_location", "bool");

   // plugins/map/epsilon_factor
   _insert_default("plugins/map/epsilon_factor", "25");
   _insert_type("plugins/map/epsilon_factor", "int");
   _insert_min("plugins/map/epsilon_factor", "10");
   _insert_max("plugins/map/epsilon_factor", "100");

   // plugins/map/min_images_per_group
   _insert_default("plugins/map/min_images_per_group", "1");
   _insert_type("plugins/map/min_images_per_group", "int");
   _insert_min("plugins/map/min_images_per_group", "1");
   _insert_max("plugins/map/min_images_per_group", "10");

   // lighttable/ui/single_module
   _insert_default("lighttable/ui/single_module", "false");
   _insert_type("lighttable/ui/single_module", "bool");

   // lighttable/ui/expose_statuses
   _insert_default("lighttable/ui/expose_statuses", "false");
   _insert_type("lighttable/ui/expose_statuses", "bool");

   // darkroom/ui/single_module
   _insert_default("darkroom/ui/single_module", "true");
   _insert_type("darkroom/ui/single_module", "bool");

   // darkroom/ui/single_module_group_only
   _insert_default("darkroom/ui/single_module_group_only", "true");
   _insert_type("darkroom/ui/single_module_group_only", "bool");

   // darkroom/ui/activate_expand
   _insert_default("darkroom/ui/activate_expand", "false");
   _insert_type("darkroom/ui/activate_expand", "bool");

   // lighttable/ui/scroll_to_module
   _insert_default("lighttable/ui/scroll_to_module", "false");
   _insert_type("lighttable/ui/scroll_to_module", "bool");

   // lighttable/ui/preview/bottom_visible
   _insert_default("lighttable/ui/preview/bottom_visible", "true");
   _insert_type("lighttable/ui/preview/bottom_visible", "bool");

   // lighttable/ui/preview/left_visible
   _insert_default("lighttable/ui/preview/left_visible", "false");
   _insert_type("lighttable/ui/preview/left_visible", "bool");

   // lighttable/ui/preview/right_visible
   _insert_default("lighttable/ui/preview/right_visible", "false");
   _insert_type("lighttable/ui/preview/right_visible", "bool");

   // lighttable/ui/preview/header_visible
   _insert_default("lighttable/ui/preview/header_visible", "false");
   _insert_type("lighttable/ui/preview/header_visible", "bool");

   // lighttable/ui/preview/toolbar_bottom_visible
   _insert_default("lighttable/ui/preview/toolbar_bottom_visible", "false");
   _insert_type("lighttable/ui/preview/toolbar_bottom_visible", "bool");

   // lighttable/ui/preview/toolbar_top_visible
   _insert_default("lighttable/ui/preview/toolbar_top_visible", "false");
   _insert_type("lighttable/ui/preview/toolbar_top_visible", "bool");

   // lighttable/ui/preview/panels_collapse_controls
   _insert_default("lighttable/ui/preview/panels_collapse_controls", "false");
   _insert_type("lighttable/ui/preview/panels_collapse_controls", "bool");

   // lighttable/ui/preview/panel_collaps_state
   _insert_default("lighttable/ui/preview/panel_collaps_state", "1");
   _insert_type("lighttable/ui/preview/panel_collaps_state", "int");

   // darkroom/ui/scroll_to_module
   _insert_default("darkroom/ui/scroll_to_module", "true");
   _insert_type("darkroom/ui/scroll_to_module", "bool");

   // darkroom/ui/sidebar_scroll_default
   _insert_default("darkroom/ui/sidebar_scroll_default", "false");
   _insert_type("darkroom/ui/sidebar_scroll_default", "bool");

   // plugins/darkroom/ui/border_size
   _insert_default("plugins/darkroom/ui/border_size", "10");
   _insert_type("plugins/darkroom/ui/border_size", "int");

   // darkroom/ui/scrollbars
   _insert_default("darkroom/ui/scrollbars", "false");
   _insert_type("darkroom/ui/scrollbars", "bool");

   // panel_scrollbars_always_visible
   _insert_default("panel_scrollbars_always_visible", "true");
   _insert_type("panel_scrollbars_always_visible", "bool");

   // ui_last/expander_metadata
   _insert_default("ui_last/expander_metadata", "0");
   _insert_type("ui_last/expander_metadata", "int");

   // ui_last/expander_navigation
   _insert_default("ui_last/expander_navigation", "-1");
   _insert_type("ui_last/expander_navigation", "int");

   // ui_last/expander_histogram
   _insert_default("ui_last/expander_histogram", "-1");
   _insert_type("ui_last/expander_histogram", "int");

   // ui_last/expander_snapshots
   _insert_default("ui_last/expander_snapshots", "-1");
   _insert_type("ui_last/expander_snapshots", "int");

   // ui_last/expander_history
   _insert_default("ui_last/expander_history", "-1");
   _insert_type("ui_last/expander_history", "int");

   // plugins/lighttable/export/force_lcms2
   _insert_default("plugins/lighttable/export/force_lcms2", "false");
   _insert_type("plugins/lighttable/export/force_lcms2", "bool");

   // plugins/lighttable/export/high_quality_processing
   _insert_default("plugins/lighttable/export/high_quality_processing", "false");
   _insert_type("plugins/lighttable/export/high_quality_processing", "bool");

   // rating_one_double_tap
   _insert_default("rating_one_double_tap", "false");
   _insert_type("rating_one_double_tap", "bool");

   // lighttable/ui/scrollbars
   _insert_default("lighttable/ui/scrollbars", "true");
   _insert_type("lighttable/ui/scrollbars", "bool");

   // darkroom/ui/rawoverexposed/mode
   _insert_default("darkroom/ui/rawoverexposed/mode", "0");
   _insert_type("darkroom/ui/rawoverexposed/mode", "int");

   // darkroom/ui/rawoverexposed/colorscheme
   _insert_default("darkroom/ui/rawoverexposed/colorscheme", "0");
   _insert_type("darkroom/ui/rawoverexposed/colorscheme", "int");

   // darkroom/ui/rawoverexposed/threshold
   _insert_default("darkroom/ui/rawoverexposed/threshold", "1.0");
   _insert_type("darkroom/ui/rawoverexposed/threshold", "float");

   // darkroom/ui/overexposed/colorscheme
   _insert_default("darkroom/ui/overexposed/colorscheme", "1");
   _insert_type("darkroom/ui/overexposed/colorscheme", "int");

   // darkroom/ui/overexposed/lower
   _insert_default("darkroom/ui/overexposed/lower", "-12.69");
   _insert_type("darkroom/ui/overexposed/lower", "float");

   // darkroom/ui/overexposed/upper
   _insert_default("darkroom/ui/overexposed/upper", "99.99");
   _insert_type("darkroom/ui/overexposed/upper", "float");

   // plugins/darkroom/channelmixerrgb/gui_page
   _insert_default("plugins/darkroom/channelmixerrgb/gui_page", "0");
   _insert_type("plugins/darkroom/channelmixerrgb/gui_page", "int");

   // plugins/darkroom/demosaic/fdc_xover_iso
   _insert_default("plugins/darkroom/demosaic/fdc_xover_iso", "1600");
   _insert_type("plugins/darkroom/demosaic/fdc_xover_iso", "int");

   // plugins/darkroom/denoiseprofile/show_compute_variance_mode
   _insert_default("plugins/darkroom/denoiseprofile/show_compute_variance_mode", "false");
   _insert_type("plugins/darkroom/denoiseprofile/show_compute_variance_mode", "bool");

   // plugins/darkroom/demosaic/quality
   _insert_default("plugins/darkroom/demosaic/quality", "at most PPG (reasonable)");
   _insert_type("plugins/darkroom/demosaic/quality", "enum");
   _insert_values("plugins/darkroom/demosaic/quality", "[always bilinear (fast)][at most PPG (reasonable)][full (possibly slow)]");

   // preview_downsampling
   _insert_default("preview_downsampling", "original");
   _insert_type("preview_downsampling", "enum");
   _insert_values("preview_downsampling", "[original][to 1/2][to 1/3][to 1/4]");

   // plugins/lighttable/export/pixel_interpolator
   _insert_default("plugins/lighttable/export/pixel_interpolator", "lanczos3");
   _insert_type("plugins/lighttable/export/pixel_interpolator", "enum");
   _insert_values("plugins/lighttable/export/pixel_interpolator", "[bilinear][bicubic][lanczos2][lanczos3]");

   // plugins/lighttable/export/dimensions_type
   _insert_default("plugins/lighttable/export/dimensions_type", "0");
   _insert_type("plugins/lighttable/export/dimensions_type", "int");
   _insert_min("plugins/lighttable/export/dimensions_type", "0");

   // plugins/lighttable/export/print_dpi
   _insert_default("plugins/lighttable/export/print_dpi", "300");
   _insert_type("plugins/lighttable/export/print_dpi", "int");
   _insert_min("plugins/lighttable/export/print_dpi", "72");
   _insert_max("plugins/lighttable/export/print_dpi", "9600");

   // plugins/lighttable/export/width
   _insert_default("plugins/lighttable/export/width", "0");
   _insert_type("plugins/lighttable/export/width", "int");
   _insert_min("plugins/lighttable/export/width", "0");

   // plugins/lighttable/export/height
   _insert_default("plugins/lighttable/export/height", "0");
   _insert_type("plugins/lighttable/export/height", "int");
   _insert_min("plugins/lighttable/export/height", "0");

   // plugins/lighttable/export/storage_name
   _insert_default("plugins/lighttable/export/storage_name", "disk");
   _insert_type("plugins/lighttable/export/storage_name", "string");

   // plugins/lighttable/export/format_name
   _insert_default("plugins/lighttable/export/format_name", "jpeg");
   _insert_type("plugins/lighttable/export/format_name", "string");

   // plugins/lighttable/export/style
   _insert_default("plugins/lighttable/export/style", "");
   _insert_type("plugins/lighttable/export/style", "string");

   // plugins/imageio/storage/disk/file_directory
   _insert_default("plugins/imageio/storage/disk/file_directory", "$(FILE_FOLDER)/darktable_exported/$(FILE_NAME)");
   _insert_type("plugins/imageio/storage/disk/file_directory", "string");

   // plugins/imageio/storage/gallery/file_directory
   _insert_default("plugins/imageio/storage/gallery/file_directory", "$(HOME)/darktable_gallery/img_$(SEQUENCE)");
   _insert_type("plugins/imageio/storage/gallery/file_directory", "string");

   // plugins/imageio/storage/gallery/title
   _insert_default("plugins/imageio/storage/gallery/title", "darktable gallery");
   _insert_type("plugins/imageio/storage/gallery/title", "string");

   // plugins/imageio/storage/email/client
   _insert_default("plugins/imageio/storage/email/client", "");
   _insert_type("plugins/imageio/storage/email/client", "string");

   // plugins/imageio/storage/gphoto/id
   _insert_default("plugins/imageio/storage/gphoto/id", "642055548087-n01fgvugnbns7a9jq8jfucjsn5l1t6so.apps.googleusercontent.com");
   _insert_type("plugins/imageio/storage/gphoto/id", "string");

   // plugins/imageio/storage/gphoto/secret
   _insert_default("plugins/imageio/storage/gphoto/secret", "o29QcbsDWS5cauRqdmGdF3sP");
   _insert_type("plugins/imageio/storage/gphoto/secret", "string");

   // plugins/imageio/format/pdf/size
   _insert_default("plugins/imageio/format/pdf/size", "a4");
   _insert_type("plugins/imageio/format/pdf/size", "string");

   // plugins/imageio/format/pdf/border
   _insert_default("plugins/imageio/format/pdf/border", "0 mm");
   _insert_type("plugins/imageio/format/pdf/border", "string");

   // plugins/imageio/format/pdf/dpi
   _insert_default("plugins/imageio/format/pdf/dpi", "300");
   _insert_type("plugins/imageio/format/pdf/dpi", "float");

   // plugins/imageio/format/pdf/compression
   _insert_default("plugins/imageio/format/pdf/compression", "1");
   _insert_type("plugins/imageio/format/pdf/compression", "int");

   // plugins/imageio/format/jpeg/quality
   _insert_default("plugins/imageio/format/jpeg/quality", "95");
   _insert_type("plugins/imageio/format/jpeg/quality", "int");

   // plugins/imageio/format/tiff/bpp
   _insert_default("plugins/imageio/format/tiff/bpp", "8");
   _insert_type("plugins/imageio/format/tiff/bpp", "int");

   // plugins/imageio/format/tiff/compress
   _insert_default("plugins/imageio/format/tiff/compress", "2");
   _insert_type("plugins/imageio/format/tiff/compress", "int");

   // plugins/imageio/format/tiff/compresslevel
   _insert_default("plugins/imageio/format/tiff/compresslevel", "6");
   _insert_type("plugins/imageio/format/tiff/compresslevel", "int");

   // plugins/imageio/format/png/bpp
   _insert_default("plugins/imageio/format/png/bpp", "8");
   _insert_type("plugins/imageio/format/png/bpp", "int");

   // plugins/imageio/format/png/compression
   _insert_default("plugins/imageio/format/png/compression", "5");
   _insert_type("plugins/imageio/format/png/compression", "int");

   // plugins/pwstorage/pwstorage_backend
   _insert_default("plugins/pwstorage/pwstorage_backend", "auto");
   _insert_type("plugins/pwstorage/pwstorage_backend", "enum");
   _insert_values("plugins/pwstorage/pwstorage_backend", "[auto][none][libsecret][kwallet]");

   // plugins/lighttable/export/icctype
   _insert_default("plugins/lighttable/export/icctype", "-1");
   _insert_type("plugins/lighttable/export/icctype", "int");

   // plugins/lighttable/export/iccprofile
   _insert_default("plugins/lighttable/export/iccprofile", "");
   _insert_type("plugins/lighttable/export/iccprofile", "string");

   // plugins/lighttable/export/iccintent
   _insert_default("plugins/lighttable/export/iccintent", "-1");
   _insert_type("plugins/lighttable/export/iccintent", "int");

   // plugins/darkroom/groups
   _insert_default("plugins/darkroom/groups", "2");
   _insert_type("plugins/darkroom/groups", "int");

   // plugins/darkroom/active
   _insert_default("plugins/darkroom/active", "");
   _insert_type("plugins/darkroom/active", "string");

   // plugins/darkroom/spots/circle_size
   _insert_default("plugins/darkroom/spots/circle_size", "0.02");
   _insert_type("plugins/darkroom/spots/circle_size", "float");

   // plugins/darkroom/spots/circle_border
   _insert_default("plugins/darkroom/spots/circle_border", "0.02");
   _insert_type("plugins/darkroom/spots/circle_border", "float");

   // plugins/darkroom/spots/ellipse_radius_a
   _insert_default("plugins/darkroom/spots/ellipse_radius_a", "0.02");
   _insert_type("plugins/darkroom/spots/ellipse_radius_a", "float");

   // plugins/darkroom/spots/ellipse_radius_b
   _insert_default("plugins/darkroom/spots/ellipse_radius_b", "0.01414");
   _insert_type("plugins/darkroom/spots/ellipse_radius_b", "float");

   // plugins/darkroom/spots/ellipse_border
   _insert_default("plugins/darkroom/spots/ellipse_border", "0.02");
   _insert_type("plugins/darkroom/spots/ellipse_border", "float");

   // plugins/darkroom/spots/ellipse_rotation
   _insert_default("plugins/darkroom/spots/ellipse_rotation", "90.0");
   _insert_type("plugins/darkroom/spots/ellipse_rotation", "float");

   // plugins/darkroom/spots/ellipse_flags
   _insert_default("plugins/darkroom/spots/ellipse_flags", "0");
   _insert_type("plugins/darkroom/spots/ellipse_flags", "int");

   // plugins/darkroom/spots/path_border
   _insert_default("plugins/darkroom/spots/path_border", "0.05");
   _insert_type("plugins/darkroom/spots/path_border", "float");

   // plugins/darkroom/spots/brush_border
   _insert_default("plugins/darkroom/spots/brush_border", "0.05");
   _insert_type("plugins/darkroom/spots/brush_border", "float");

   // plugins/darkroom/spots/brush_density
   _insert_default("plugins/darkroom/spots/brush_density", "1.0");
   _insert_type("plugins/darkroom/spots/brush_density", "float");

   // plugins/darkroom/spots/brush_hardness
   _insert_default("plugins/darkroom/spots/brush_hardness", "0.66");
   _insert_type("plugins/darkroom/spots/brush_hardness", "float");

   // plugins/darkroom/clipping/ratio_d
   _insert_default("plugins/darkroom/clipping/ratio_d", "0");
   _insert_type("plugins/darkroom/clipping/ratio_d", "int");

   // plugins/darkroom/clipping/ratio_n
   _insert_default("plugins/darkroom/clipping/ratio_n", "0");
   _insert_type("plugins/darkroom/clipping/ratio_n", "int");

   // plugins/darkroom/clipping/guide
   _insert_default("plugins/darkroom/clipping/guide", "0");
   _insert_type("plugins/darkroom/clipping/guide", "int");

   // plugins/darkroom/histogram/height
   _insert_default("plugins/darkroom/histogram/height", "175");
   _insert_type("plugins/darkroom/histogram/height", "int");
   _insert_min("plugins/darkroom/histogram/height", "100");
   _insert_max("plugins/darkroom/histogram/height", "200");

   // plugins/darkroom/histogram/mode
   _insert_default("plugins/darkroom/histogram/mode", "histogram");
   _insert_type("plugins/darkroom/histogram/mode", "enum");
   _insert_values("plugins/darkroom/histogram/mode", "[histogram][waveform]");

   // plugins/darkroom/histogram/histogram
   _insert_default("plugins/darkroom/histogram/histogram", "logarithmic");
   _insert_type("plugins/darkroom/histogram/histogram", "enum");
   _insert_values("plugins/darkroom/histogram/histogram", "[logarithmic][linear]");

   // plugins/darkroom/histogram/waveform
   _insert_default("plugins/darkroom/histogram/waveform", "overlaid");
   _insert_type("plugins/darkroom/histogram/waveform", "enum");
   _insert_values("plugins/darkroom/histogram/waveform", "[overlaid][parade]");

   // plugins/darkroom/histogram/show_red
   _insert_default("plugins/darkroom/histogram/show_red", "true");
   _insert_type("plugins/darkroom/histogram/show_red", "bool");

   // plugins/darkroom/histogram/show_green
   _insert_default("plugins/darkroom/histogram/show_green", "true");
   _insert_type("plugins/darkroom/histogram/show_green", "bool");

   // plugins/darkroom/histogram/show_blue
   _insert_default("plugins/darkroom/histogram/show_blue", "true");
   _insert_type("plugins/darkroom/histogram/show_blue", "bool");

   // plugins/darkroom/masks/opacity
   _insert_default("plugins/darkroom/masks/opacity", "1.0");
   _insert_type("plugins/darkroom/masks/opacity", "float");

   // plugins/darkroom/masks/circle/size
   _insert_default("plugins/darkroom/masks/circle/size", "0.05");
   _insert_type("plugins/darkroom/masks/circle/size", "float");

   // plugins/darkroom/masks/circle/border
   _insert_default("plugins/darkroom/masks/circle/border", "0.05");
   _insert_type("plugins/darkroom/masks/circle/border", "float");

   // plugins/darkroom/masks/ellipse/radius_a
   _insert_default("plugins/darkroom/masks/ellipse/radius_a", "0.05");
   _insert_type("plugins/darkroom/masks/ellipse/radius_a", "float");

   // plugins/darkroom/masks/ellipse/radius_b
   _insert_default("plugins/darkroom/masks/ellipse/radius_b", "0.03535");
   _insert_type("plugins/darkroom/masks/ellipse/radius_b", "float");

   // plugins/darkroom/masks/ellipse/border
   _insert_default("plugins/darkroom/masks/ellipse/border", "0.05");
   _insert_type("plugins/darkroom/masks/ellipse/border", "float");

   // plugins/darkroom/masks/ellipse/rotation
   _insert_default("plugins/darkroom/masks/ellipse/rotation", "90.0");
   _insert_type("plugins/darkroom/masks/ellipse/rotation", "float");

   // plugins/darkroom/masks/ellipse/flags
   _insert_default("plugins/darkroom/masks/ellipse/flags", "0");
   _insert_type("plugins/darkroom/masks/ellipse/flags", "int");

   // plugins/darkroom/masks/path/border
   _insert_default("plugins/darkroom/masks/path/border", "0.05");
   _insert_type("plugins/darkroom/masks/path/border", "float");

   // plugins/darkroom/masks/gradient/rotation
   _insert_default("plugins/darkroom/masks/gradient/rotation", "0.0");
   _insert_type("plugins/darkroom/masks/gradient/rotation", "float");

   // plugins/darkroom/masks/gradient/compression
   _insert_default("plugins/darkroom/masks/gradient/compression", "0.5");
   _insert_type("plugins/darkroom/masks/gradient/compression", "float");

   // plugins/darkroom/masks/gradient/steepness
   _insert_default("plugins/darkroom/masks/gradient/steepness", "0.0");
   _insert_type("plugins/darkroom/masks/gradient/steepness", "float");

   // plugins/darkroom/masks/brush/border
   _insert_default("plugins/darkroom/masks/brush/border", "0.05");
   _insert_type("plugins/darkroom/masks/brush/border", "float");

   // plugins/darkroom/masks/brush/density
   _insert_default("plugins/darkroom/masks/brush/density", "1.0");
   _insert_type("plugins/darkroom/masks/brush/density", "float");

   // plugins/darkroom/masks/brush/hardness
   _insert_default("plugins/darkroom/masks/brush/hardness", "0.66");
   _insert_type("plugins/darkroom/masks/brush/hardness", "float");

   // plugins/darkroom/masks/heightview
   _insert_default("plugins/darkroom/masks/heightview", "300");
   _insert_type("plugins/darkroom/masks/heightview", "int");
   _insert_min("plugins/darkroom/masks/heightview", "100");
   _insert_max("plugins/darkroom/masks/heightview", "1000");

   // plugins/darkroom/ashift/near_delta
   _insert_default("plugins/darkroom/ashift/near_delta", "20.0");
   _insert_type("plugins/darkroom/ashift/near_delta", "float");

   // plugins/print/print/black_point_compensation
   _insert_default("plugins/print/print/black_point_compensation", "true");
   _insert_type("plugins/print/print/black_point_compensation", "bool");

   // ui_last/display_profile_source
   _insert_default("ui_last/display_profile_source", "all");
   _insert_type("ui_last/display_profile_source", "enum");
   _insert_values("ui_last/display_profile_source", "[all][xatom][colord]");

   // metadata/resolution
   _insert_default("metadata/resolution", "300");
   _insert_type("metadata/resolution", "int");

   // run_crawler_on_start
   _insert_default("run_crawler_on_start", "false");
   _insert_type("run_crawler_on_start", "bool");

   // plugins/lighttable/audio_player
   _insert_default("plugins/lighttable/audio_player", "aplay");
   _insert_type("plugins/lighttable/audio_player", "string");

   // plugins/darkroom/lut3d/def_path
   _insert_default("plugins/darkroom/lut3d/def_path", "");
   _insert_type("plugins/darkroom/lut3d/def_path", "dir");

   // plugins/darkroom/workflow
   _insert_default("plugins/darkroom/workflow", "display-referred");
   _insert_type("plugins/darkroom/workflow", "enum");
   _insert_values("plugins/darkroom/workflow", "[scene-referred][display-referred][none]");

   // plugins/darkroom/chromatic-adaptation
   _insert_default("plugins/darkroom/chromatic-adaptation", "legacy");
   _insert_type("plugins/darkroom/chromatic-adaptation", "enum");
   _insert_values("plugins/darkroom/chromatic-adaptation", "[modern][legacy]");

   // plugins/darkroom/basecurve/auto_apply_percamera_presets
   _insert_default("plugins/darkroom/basecurve/auto_apply_percamera_presets", "false");
   _insert_type("plugins/darkroom/basecurve/auto_apply_percamera_presets", "bool");

   // plugins/darkroom/sharpen/auto_apply
   _insert_default("plugins/darkroom/sharpen/auto_apply", "true");
   _insert_type("plugins/darkroom/sharpen/auto_apply", "bool");

   // ui/detect_mono_exif
   _insert_default("ui/detect_mono_exif", "false");
   _insert_type("ui/detect_mono_exif", "bool");

   // screen_dpi_overwrite
   _insert_default("screen_dpi_overwrite", "-1.0");
   _insert_type("screen_dpi_overwrite", "float");

   // ui/performance
   _insert_default("ui/performance", "false");
   _insert_type("ui/performance", "bool");

   // plugins/lighttable/preview/max_in_memory_images
   _insert_default("plugins/lighttable/preview/max_in_memory_images", "4");
   _insert_type("plugins/lighttable/preview/max_in_memory_images", "int");

   // codepaths/sse2
   _insert_default("codepaths/sse2", "true");
   _insert_type("codepaths/sse2", "bool");

   // codepaths/openmp_simd
   _insert_default("codepaths/openmp_simd", "false");
   _insert_type("codepaths/openmp_simd", "bool");

   // allow_lab_output
   _insert_default("allow_lab_output", "false");
   _insert_type("allow_lab_output", "bool");

   // plugins/darkroom/rawprepare/allow_editing_crop
   _insert_default("plugins/darkroom/rawprepare/allow_editing_crop", "false");
   _insert_type("plugins/darkroom/rawprepare/allow_editing_crop", "bool");

   // plugins/darkroom/modulegroups_preset
   _insert_default("plugins/darkroom/modulegroups_preset", "");
   _insert_type("plugins/darkroom/modulegroups_preset", "string");

   // plugins/map/geotagging_search_url
   _insert_default("plugins/map/geotagging_search_url", "https://nominatim.openstreetmap.org/search/%s?format=xml&limit=%d&polygon_text=1");
   _insert_type("plugins/map/geotagging_search_url", "string");

   // plugins/darkroom/temperature/colored_sliders
   _insert_default("plugins/darkroom/temperature/colored_sliders", "no color");
   _insert_type("plugins/darkroom/temperature/colored_sliders", "enum");
   _insert_values("plugins/darkroom/temperature/colored_sliders", "[no color][illuminant color][effect emulation]");

   // plugins/darkroom/temperature/expand_coefficients
   _insert_default("plugins/darkroom/temperature/expand_coefficients", "false");
   _insert_type("plugins/darkroom/temperature/expand_coefficients", "bool");

   // plugins/darkroom/temperature/button_bar
   _insert_default("plugins/darkroom/temperature/button_bar", "true");
   _insert_type("plugins/darkroom/temperature/button_bar", "bool");

   // plugins/darkroom/colorbalance/layout
   _insert_default("plugins/darkroom/colorbalance/layout", "list");
   _insert_type("plugins/darkroom/colorbalance/layout", "enum");
   _insert_values("plugins/darkroom/colorbalance/layout", "[list][tabs][columns]");

   // darkroom/ui/hide_header_buttons
   _insert_default("darkroom/ui/hide_header_buttons", "always");
   _insert_type("darkroom/ui/hide_header_buttons", "enum");
   _insert_values("darkroom/ui/hide_header_buttons", "[always][active][dim][auto][fade][fit][smooth][glide]");

   // plugins/darkroom/temperature/visible
   _insert_default("plugins/darkroom/temperature/visible", "true");
   _insert_type("plugins/darkroom/temperature/visible", "bool");

   // plugins/darkroom/exposure/visible
   _insert_default("plugins/darkroom/exposure/visible", "true");
   _insert_type("plugins/darkroom/exposure/visible", "bool");

   // plugins/darkroom/colorbalance/visible
   _insert_default("plugins/darkroom/colorbalance/visible", "true");
   _insert_type("plugins/darkroom/colorbalance/visible", "bool");

   // plugins/darkroom/colorin/visible
   _insert_default("plugins/darkroom/colorin/visible", "true");
   _insert_type("plugins/darkroom/colorin/visible", "bool");

   // plugins/darkroom/clipping/visible
   _insert_default("plugins/darkroom/clipping/visible", "true");
   _insert_type("plugins/darkroom/clipping/visible", "bool");

   // plugins/darkroom/sharpen/visible
   _insert_default("plugins/darkroom/sharpen/visible", "true");
   _insert_type("plugins/darkroom/sharpen/visible", "bool");

   // plugins/darkroom/basecurve/visible
   _insert_default("plugins/darkroom/basecurve/visible", "true");
   _insert_type("plugins/darkroom/basecurve/visible", "bool");

   // plugins/darkroom/highlights/visible
   _insert_default("plugins/darkroom/highlights/visible", "true");
   _insert_type("plugins/darkroom/highlights/visible", "bool");

   // plugins/darkroom/demosaic/visible
   _insert_default("plugins/darkroom/demosaic/visible", "true");
   _insert_type("plugins/darkroom/demosaic/visible", "bool");

   // plugins/darkroom/rgblevels/visible
   _insert_default("plugins/darkroom/rgblevels/visible", "true");
   _insert_type("plugins/darkroom/rgblevels/visible", "bool");

   // plugins/darkroom/flip/visible
   _insert_default("plugins/darkroom/flip/visible", "true");
   _insert_type("plugins/darkroom/flip/visible", "bool");

   // plugins/darkroom/bilat/visible
   _insert_default("plugins/darkroom/bilat/visible", "true");
   _insert_type("plugins/darkroom/bilat/visible", "bool");

   // plugins/darkroom/denoiseprofile/visible
   _insert_default("plugins/darkroom/denoiseprofile/visible", "true");
   _insert_type("plugins/darkroom/denoiseprofile/visible", "bool");

   // plugins/darkroom/hazeremoval/visible
   _insert_default("plugins/darkroom/hazeremoval/visible", "true");
   _insert_type("plugins/darkroom/hazeremoval/visible", "bool");

   // plugins/darkroom/toneequal/visible
   _insert_default("plugins/darkroom/toneequal/visible", "true");
   _insert_type("plugins/darkroom/toneequal/visible", "bool");

   // plugins/darkroom/lens/visible
   _insert_default("plugins/darkroom/lens/visible", "true");
   _insert_type("plugins/darkroom/lens/visible", "bool");

   // darkroom/ui/scale_step_multiplier
   _insert_default("darkroom/ui/scale_step_multiplier", "1.0");
   _insert_type("darkroom/ui/scale_step_multiplier", "float");

   // darkroom/ui/scale_rough_step_multiplier
   _insert_default("darkroom/ui/scale_rough_step_multiplier", "10.0");
   _insert_type("darkroom/ui/scale_rough_step_multiplier", "float");

   // darkroom/ui/scale_precise_step_multiplier
   _insert_default("darkroom/ui/scale_precise_step_multiplier", "0.1");
   _insert_type("darkroom/ui/scale_precise_step_multiplier", "float");

   // performance_configuration_version_completed
   _insert_default("performance_configuration_version_completed", "0");
   _insert_type("performance_configuration_version_completed", "int");

   // plugins/darkroom/duplicate/windowheight
   _insert_default("plugins/darkroom/duplicate/windowheight", "400");
   _insert_type("plugins/darkroom/duplicate/windowheight", "int");

   // plugins/darkroom/colorpicker/windowheight
   _insert_default("plugins/darkroom/colorpicker/windowheight", "200");
   _insert_type("plugins/darkroom/colorpicker/windowheight", "int");

   // plugins/darkroom/history/windowheight
   _insert_default("plugins/darkroom/history/windowheight", "1000");
   _insert_type("plugins/darkroom/history/windowheight", "int");

   // plugins/lighttable/metadata_view/windowheight
   _insert_default("plugins/lighttable/metadata_view/windowheight", "1000");
   _insert_type("plugins/lighttable/metadata_view/windowheight", "int");

   // plugins/lighttable/recentcollect/windowheight
   _insert_default("plugins/lighttable/recentcollect/windowheight", "1000");
   _insert_type("plugins/lighttable/recentcollect/windowheight", "int");

   // plugins/darkroom/snapshots/windowheight
   _insert_default("plugins/darkroom/snapshots/windowheight", "200");
   _insert_type("plugins/darkroom/snapshots/windowheight", "int");

   // plugins/lighttable/style/windowheight
   _insert_default("plugins/lighttable/style/windowheight", "400");
   _insert_type("plugins/lighttable/style/windowheight", "int");

   // plugins/darkroom/toneequal/gui_page
   _insert_default("plugins/darkroom/toneequal/gui_page", "0");
   _insert_type("plugins/darkroom/toneequal/gui_page", "int");

}
#endif